#!/usr/bin/env python

import copy, struct
import dpkt, fragroute

class InsPAWS(fragroute.Fragroute):
    def transform(self, ip):
        pkts = []
        for ip in self.tcp_seg(ip, 1):
            if ip.tcp.data and ip.tcp.seq & 1:
                ip2 = copy.deepcopy(ip)
                ip2.tcp.opts = struct.pack('BBBBII',
                    dpkt.tcp.TCP_OPT_NOP, dpkt.tcp.TCP_OPT_NOP,
                    dpkt.tcp.TCP_OPT_TIMESTAMP, 10, 0, 0)
                ip2.tcp.hl = len(ip2.tcp.opts) >> 2
                ip2.tcp.data = self.rand.get(len(ip.tcp.data))
                ip2.len = 20 + len(ip2.tcp)
                ip2.sum = ip2.tcp.sum = 0
                pkts.append(ip2)
            pkts.append(ip)
        return pkts

if __name__ == '__main__':
    fragroute.main()
