#!/usr/bin/env python

import dpkt, fragroute, p0f

class p0fsp00f(fragroute.Fragroute):
    def __init__(self):
        fragroute.Fragroute.__init__(self)
        self.op.add_option('-o', action='callback', callback=self.parse_os,
                           dest='os', type='string',
                           default=('Windows', '2000 SP4, XP SP1'),
                           help='operating system (default "Windows 2000 SP4, XP SP1")')
        self.p0f = p0f.P0f(match=False, rewrite=True)

    def parse_os(self, option, opt, value, parser):
        setattr(parser.values, option.dest, value.split(None, 1))
    
    def transform(self, ip):
        if ip.p == dpkt.ip.IP_PROTO_TCP and ip.tcp.flags == dpkt.tcp.TH_SYN:
            self.p0f.rewrite(ip, *self.opts.os)
            ip.sum = ip.tcp.sum = 0
        return [ ip ]

if __name__ == '__main__':
    fragroute.main()
