#!/usr/bin/env python

import copy
import dpkt, fragroute

class Tcbc2(fragroute.Fragroute):
    def transform(self, ip):
        pkts = []
        for ip in self.tcp_seg(ip, 1):
            if ip.tcp.data:
                ip2 = copy.deepcopy(ip)
                ip2.tcp.flags = dpkt.tcp.TH_SYN
                ip2.tcp.data = self.rand.get(len(ip2.tcp.data))
                ip2.id = self.rand.uint16()
                ip2.sum = ip2.tcp.sum = 0
                pkts.append(ip2)
            pkts.append(ip)
        return pkts

if __name__ == '__main__':
    fragroute.main()
